from rest_framework import serializers
from reqman.apps.reqtool.models.main_req import Main, Main_M1, Main_M2, Main_M3, Main_M4
from reqman.apps.reqtool.models.main_req import Main_M5, Main_M6, Main_M7, Main_M8
from reqman.apps.reqtool.models.main_req import Main_M9, Main_M10, Main_M11, Main_M12
from reqman.apps.reqtool.models.main_req import Main_M13, Main_M14, Main_M15, Main_M16


class MainSerializer(serializers.ModelSerializer):
    boilerplate_of_main = serializers.PrimaryKeyRelatedField(read_only=True)
    prefix_owner_of_main = serializers.PrimaryKeyRelatedField(read_only=True)
    class Meta:
        model = Main
        fields = ( 'id', 'prefix_owner_of_main', 'boilerplate_of_main', 'main_choices')


class Main_M1Serializer(serializers.ModelSerializer):
    boilerplate_of_m1 = serializers.PrimaryKeyRelatedField(read_only=True)
    main_owner_of_m1 = serializers.PrimaryKeyRelatedField(read_only=True)
    class Meta:
        model = Main_M1
        fields = ( 'id', 'boilerplate_of_m1', 'main_owner_of_m1', 'sys_fun_m1', 'shall_m1', 'quantifier_m1', 'numerical_m1', 'mumerical_units_m1', 'item_m1', 'statevalue_m1')


class Main_M2Serializer(serializers.ModelSerializer):
    boilerplate_of_m2 = serializers.PrimaryKeyRelatedField(read_only=True)
    main_owner_of_m2 = serializers.PrimaryKeyRelatedField(read_only=True)
    class Meta:
        model = Main_M2
        fields = ( 'id', 'boilerplate_of_m2', 'main_owner_of_m2', 'sys_fun_m2', 'shall_m2', 'state_m2', 'statevalue_m2')


class Main_M3Serializer(serializers.ModelSerializer):
    boilerplate_of_m3 = serializers.PrimaryKeyRelatedField(read_only=True)
    main_owner_of_m3 = serializers.PrimaryKeyRelatedField(read_only=True)
    class Meta:
        model = Main_M3
        fields = ( 'id', 'boilerplate_of_m3', 'main_owner_of_m3', 'sys_fun_m3', 'shall_m3', 'quantifier_m3', 'numerical_m3', 'mumerical_units_m3', 'item_m3')


class Main_M4Serializer(serializers.ModelSerializer):
    boilerplate_of_m4 = serializers.PrimaryKeyRelatedField(read_only=True)
    main_owner_of_m4 = serializers.PrimaryKeyRelatedField(read_only=True)
    class Meta:
        model = Main_M4
        fields = ( 'id', 'boilerplate_of_m4', 'main_owner_of_m4', 'sys_fun_m4', 'shall_m4', 'quantifier_m4', 'numerical_m4', 'mumerical_units_m4', 'item_m4')


class Main_M5Serializer(serializers.ModelSerializer):
    boilerplate_of_m5 = serializers.PrimaryKeyRelatedField(read_only=True)
    main_owner_of_m5 = serializers.PrimaryKeyRelatedField(read_only=True)
    class Meta:
        model = Main_M5
        fields = ( 'id', 'boilerplate_of_m5', 'main_owner_of_m5', 'sys_fun_m5', 'shall_m5', 'flow_m5')


class Main_M6Serializer(serializers.ModelSerializer):
    boilerplate_of_m6 = serializers.PrimaryKeyRelatedField(read_only=True)
    main_owner_of_m6 = serializers.PrimaryKeyRelatedField(read_only=True)
    class Meta:
        model = Main_M6
        fields = ( 'id', 'boilerplate_of_m6', 'main_owner_of_m6', 'sys_fun_m6', 'shall_m6', 'flow_m6')


class Main_M7Serializer(serializers.ModelSerializer):
    boilerplate_of_m7 = serializers.PrimaryKeyRelatedField(read_only=True)
    main_owner_of_m7 = serializers.PrimaryKeyRelatedField(read_only=True)
    class Meta:
        model = Main_M7
        fields = ( 'id', 'boilerplate_of_m7', 'main_owner_of_m7', 'system_m7', 'shall_m7', 'function_m7')


class Main_M8Serializer(serializers.ModelSerializer):
    boilerplate_of_m8 = serializers.PrimaryKeyRelatedField(read_only=True)
    main_owner_of_m8 = serializers.PrimaryKeyRelatedField(read_only=True)
    class Meta:
        model = Main_M8
        fields = ( 'id', 'boilerplate_of_m8', 'main_owner_of_m8', 'function_1_m8', 'shall_m8', 'function_2_m8')


class Main_M9Serializer(serializers.ModelSerializer):
    boilerplate_of_m9 = serializers.PrimaryKeyRelatedField(read_only=True)
    main_owner_of_m9 = serializers.PrimaryKeyRelatedField(read_only=True)
    class Meta:
        model = Main_M9
        fields = ( 'id', 'boilerplate_of_m9', 'main_owner_of_m9', 'system_1_m9', 'shall_m9', 'interface_m9', 'system_2_m9')


class Main_M10Serializer(serializers.ModelSerializer):
    boilerplate_of_m10 = serializers.PrimaryKeyRelatedField(read_only=True)
    main_owner_of_m10 = serializers.PrimaryKeyRelatedField(read_only=True)
    class Meta:
        model = Main_M10
        fields = ( 'id', 'boilerplate_of_m10', 'main_owner_of_m10', 'sys_inter_m10', 'shall_m10', 'flow_item_m9')


class Main_M11Serializer(serializers.ModelSerializer):
    boilerplate_of_m11 = serializers.PrimaryKeyRelatedField(read_only=True)
    main_owner_of_m11 = serializers.PrimaryKeyRelatedField(read_only=True)
    class Meta:
        model = Main_M11
        fields = ( 'id', 'boilerplate_of_m11', 'main_owner_of_m11', 'system_1_m11', 'shall_m11', 'system_2_m11', 'connection_m11')


class Main_M12Serializer(serializers.ModelSerializer):
    boilerplate_of_m12 = serializers.PrimaryKeyRelatedField(read_only=True)
    main_owner_of_m12 = serializers.PrimaryKeyRelatedField(read_only=True)
    class Meta:
        model = Main_M12
        fields = ( 'id', 'boilerplate_of_m12', 'main_owner_of_m12', 'system_m12', 'shall_m12', 'state_m12')


class Main_M13Serializer(serializers.ModelSerializer):
    boilerplate_of_m13 = serializers.PrimaryKeyRelatedField(read_only=True)
    main_owner_of_m13 = serializers.PrimaryKeyRelatedField(read_only=True)
    class Meta:
        model = Main_M13
        fields = ( 'id', 'boilerplate_of_m13', 'main_owner_of_m13', 'system_m13', 'state_1_m13', 'statevalue_m13', 'shall_m13', 'state_2_m13')


class Main_M14Serializer(serializers.ModelSerializer):
    boilerplate_of_m14 = serializers.PrimaryKeyRelatedField(read_only=True)
    main_owner_of_m14 = serializers.PrimaryKeyRelatedField(read_only=True)
    class Meta:
        model = Main_M14
        fields = ( 'id', 'boilerplate_of_m14', 'main_owner_of_m14', 'system_m14', 'item_m14', 'shall_m14')


class Main_M15Serializer(serializers.ModelSerializer):
    boilerplate_of_m15 = serializers.PrimaryKeyRelatedField(read_only=True)
    main_owner_of_m15 = serializers.PrimaryKeyRelatedField(read_only=True)
    class Meta:
        model = Main_M15
        fields = ( 'id', 'boilerplate_of_m15', 'main_owner_of_m15', 'system_m15', 'item_1_m15', 'shall_m15', 'item_2_m15')


class Main_M16Serializer(serializers.ModelSerializer):
    boilerplate_of_m16 = serializers.PrimaryKeyRelatedField(read_only=True)
    main_owner_of_m16 = serializers.PrimaryKeyRelatedField(read_only=True)
    class Meta:
        model = Main_M16
        fields = ( 'id', 'boilerplate_of_m16', 'main_owner_of_m16', 'system_1_m16', 'shall_m16', 'system_2_m16')




